<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `crates/framework/capdl/loader/core/src/hold_slots.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>hold_slots.rs - source</title><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Regular.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../FiraSans-Medium.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Regular.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceSerif4-Bold.ttf.woff2"><link rel="preload" as="font" type="font/woff2" crossorigin href="../../SourceCodePro-Semibold.ttf.woff2"><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled><link rel="stylesheet" type="text/css" href="../../dark.css" disabled><link rel="stylesheet" type="text/css" href="../../light.css" id="themeStyle"><script id="default-settings" ></script><script src="../../storage.js"></script><script defer src="../../source-script.js"></script><script defer src="../../source-files.js"></script><script defer src="../../main.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="mobile-topbar"><button class="sidebar-menu-toggle">&#9776;</button><a class="sidebar-logo" href="../../capdl_loader_core/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a><h2 class="location"></h2>
    </nav>
    <nav class="sidebar"><a class="sidebar-logo" href="../../capdl_loader_core/index.html"><div class="logo-container"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></div>
        </a></nav><main><div class="width-limiter"><div class="sub-container"><a class="sub-logo-container" href="../../capdl_loader_core/index.html"><img class="rust-logo" src="../../rust-logo.svg" alt="logo"></a><nav class="sub"><form class="search-form"><div class="search-container"><span></span><input class="search-input" name="search" autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"><div id="help-button" title="help" tabindex="-1"><button type="button">?</button></div><div id="settings-menu" tabindex="-1">
                                <a href="../../settings.html" title="settings"><img width="22" height="22" alt="Change settings" src="../../wheel.svg"></a></div>
                        </div></form></nav></div><section id="main-content" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">1</span>
<span id="2">2</span>
<span id="3">3</span>
<span id="4">4</span>
<span id="5">5</span>
<span id="6">6</span>
<span id="7">7</span>
<span id="8">8</span>
<span id="9">9</span>
<span id="10">10</span>
<span id="11">11</span>
<span id="12">12</span>
<span id="13">13</span>
<span id="14">14</span>
<span id="15">15</span>
<span id="16">16</span>
<span id="17">17</span>
<span id="18">18</span>
<span id="19">19</span>
<span id="20">20</span>
<span id="21">21</span>
<span id="22">22</span>
<span id="23">23</span>
<span id="24">24</span>
<span id="25">25</span>
<span id="26">26</span>
<span id="27">27</span>
<span id="28">28</span>
<span id="29">29</span>
<span id="30">30</span>
<span id="31">31</span>
<span id="32">32</span>
<span id="33">33</span>
<span id="34">34</span>
<span id="35">35</span>
<span id="36">36</span>
<span id="37">37</span>
<span id="38">38</span>
<span id="39">39</span>
<span id="40">40</span>
<span id="41">41</span>
<span id="42">42</span>
</pre><pre class="rust"><code><span class="kw">use</span> <span class="ident">core::array</span>;

<span class="kw">use</span> <span class="ident">icecap_core::sel4::prelude</span>::<span class="kw-2">*</span>;
<span class="kw">use</span> <span class="ident">icecap_core::sel4::InitCSpaceSlot</span>;

<span class="kw">use</span> <span class="kw">crate</span>::{<span class="ident">CSlotAllocator</span>, <span class="ident">CapDLLoaderError</span>};

<span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">struct</span> <span class="ident">HoldSlots</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> {
    <span class="ident">slots</span>: [<span class="ident">InitCSpaceSlot</span>; <span class="number">2</span>],
    <span class="ident">slots_occupied</span>: [<span class="ident">bool</span>; <span class="number">2</span>],
    <span class="ident">which_slot</span>: <span class="ident">usize</span>,
    <span class="ident">relative_cptr_of</span>: <span class="ident">T</span>,
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> <span class="ident">HoldSlots</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> {
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">new</span>(
        <span class="ident">cslot_allocator</span>: <span class="kw-2">&amp;mut</span> <span class="ident">CSlotAllocator</span>,
        <span class="ident">relative_cptr_of</span>: <span class="ident">T</span>,
    ) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="self">Self</span>, <span class="ident">CapDLLoaderError</span><span class="op">&gt;</span> {
        <span class="prelude-val">Ok</span>(<span class="self">Self</span> {
            <span class="ident">slots</span>: <span class="ident">array::try_from_fn</span>(<span class="op">|</span><span class="kw">_</span><span class="op">|</span> <span class="ident">cslot_allocator</span>.<span class="ident">alloc</span>())<span class="question-mark">?</span>,
            <span class="ident">slots_occupied</span>: [<span class="bool-val">false</span>; <span class="number">2</span>],
            <span class="ident">which_slot</span>: <span class="number">0</span>,
            <span class="ident">relative_cptr_of</span>,
        })
    }
}

<span class="kw">impl</span><span class="op">&lt;</span><span class="ident">T</span>: <span class="ident">FnMut</span>(<span class="ident">InitCSpaceSlot</span>) -&gt; <span class="ident">RelativeCPtr</span><span class="op">&gt;</span> <span class="ident">HoldSlots</span><span class="op">&lt;</span><span class="ident">T</span><span class="op">&gt;</span> {
    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">get_slot</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>) -&gt; <span class="prelude-ty">Result</span><span class="op">&lt;</span><span class="ident">InitCSpaceSlot</span>, <span class="ident">CapDLLoaderError</span><span class="op">&gt;</span> {
        <span class="kw">if</span> <span class="self">self</span>.<span class="ident">slots_occupied</span>[<span class="self">self</span>.<span class="ident">which_slot</span>] {
            (<span class="self">self</span>.<span class="ident">relative_cptr_of</span>)(<span class="self">self</span>.<span class="ident">slots</span>[<span class="self">self</span>.<span class="ident">which_slot</span>]).<span class="ident">delete</span>()<span class="question-mark">?</span>;
            <span class="self">self</span>.<span class="ident">slots_occupied</span>[<span class="self">self</span>.<span class="ident">which_slot</span>] <span class="op">=</span> <span class="bool-val">false</span>;
        }
        <span class="prelude-val">Ok</span>(<span class="self">self</span>.<span class="ident">slots</span>[<span class="self">self</span>.<span class="ident">which_slot</span>])
    }

    <span class="kw">pub</span>(<span class="kw">crate</span>) <span class="kw">fn</span> <span class="ident">report_used</span>(<span class="kw-2">&amp;mut</span> <span class="self">self</span>) {
        <span class="self">self</span>.<span class="ident">slots_occupied</span>[<span class="self">self</span>.<span class="ident">which_slot</span>] <span class="op">=</span> <span class="bool-val">true</span>;
        <span class="self">self</span>.<span class="ident">which_slot</span> <span class="op">=</span> (<span class="self">self</span>.<span class="ident">which_slot</span> <span class="op">+</span> <span class="number">1</span>) <span class="op">%</span> <span class="number">2</span>;
    }
}
</code></pre></div>
</section></div></main><div id="rustdoc-vars" data-root-path="../../" data-current-crate="capdl_loader_core" data-themes="ayu,dark,light" data-resource-suffix="" data-rustdoc-version="1.64.0-dev" ></div>
</body></html>